import Vue from 'vue'
import App from './App.vue' //Root component all components stem from
import router from './router'
import store from './store'
// import BaseIcon from '@/components/BaseIcon.vue'

// This is an example of globally registering a component
// This works for a few componets but we will use a cookbook item
// From the docs to automatically register components
// Vue.component('BaseIcon', BaseIcon)

import upperFirst from 'lodash/upperFirst'
import camelCase from 'lodash/camelCase'

const requireComponent = require.context(
  './components', // the relative path of the directory to search
  false, // subdirectories will not be searched
  /Base[A-Z]\w+\.(vue|js)$/ // regular expression that searches for components starting with "Base" and ending in .vue or .js
)

requireComponent.keys().forEach(fileName => {
  const componentConfig = requireComponent(fileName)

  const componentName = upperFirst(
    camelCase(fileName.replace(/^\.\/(.*)\.\w+$/, '$1'))
  )

  Vue.component(componentName, componentConfig.default || componentConfig)
})

Vue.config.productionTip = false

new Vue({
  router, // in ES6 this is the same as writing router: router
  store,
  render: h => h(App)
}).$mount('#app')
