import Vue from 'vue'
import Router from 'vue-router'
import EventList from './views/EventList.vue'
import EventShow from './views/EventShow.vue'
import EventCreate from './views/EventCreate.vue'
import NotFound from './views/NotFound.vue'

Vue.use(Router)

export default new Router({
  // this uses the browers `history.pushstate` API to change the page without refreshs or that # sign in the url
  // IN PRODUCTION you will need to have the right server config to ensure that all routes return /index.html like in
  // this example nginx setup:
  // location / {
  //   try_files $uri $uri /index.html;
  //}
  // THIS MEANS the server won't serve up 404 errors! Look at a solution at the bottom of the routes for a way around this.

  mode: 'history',
  base: process.env.BASE_URL,
  routes: [
    {
      path: '/',
      name: 'event-list',
      component: EventList
    },
    {
      path: '/event/:event_id',
      name: 'event-show',
      component: EventShow,
      props: true
    },
    {
      path: '/event/create',
      name: 'event-create',
      component: EventCreate
    },
    // MUST BE THE LAST ROUTE TO CATCH 404s
    {
      path: '*',
      component: NotFound
    }
    // {
    //   path: '/',
    //   // This is a named route. We can reference this instead of a static path in our router-links.
    //   name: 'home',
    //   component: Home
    // },
    // {
    //   path: '/about-us',
    //   name: 'about',
    //   // route level code-splitting
    //   // this generates a separate chunk (about.[hash].js) for this route
    //   // which is lazy-loaded when the route is visited.
    //   component: () =>
    //     import(/* webpackChunkName: "about" */ './views/About.vue'),
    //   // an alias is also a viable option instead of a redirect like below
    //   alias: '/about-alias'
    // },
    // {
    //   path: '/about',
    //   // here we are specifying the named route for the redirect.
    //   // If you weren't using Named Routes you could also do `redirects: '/about-us'`
    //   redirect: { name: 'about' }
    // }
    // This is an example of dynamic routing where the router treats the contents after the semi-colon as a parameter for your component.
    // This is av
    // {
    //   path: "/user/:username",
    //   name: "user-by-name",
    //   component: User
    //   props: true // sends the $route.params into your component as props.
    // }
  ]
})
